Index: loader/source/update-old.c
===================================================================
--- loader/source/update-old.c	(nonexistent)
+++ loader/source/update-old.c	(working copy)
@@ -0,0 +1,517 @@
+/*
+
+Nintendont (Loader) - Playing Gamecubes in Wii mode on a Wii U
+
+Copyright (C) 2014  JoostinOnline
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation version 2.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+
+#include <gccore.h>
+#include <string.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <malloc.h>
+#include <network.h>
+
+#include <zlib.h>
+#include <ogc/lwp_watchdog.h>
+
+#include "exi.h"
+#include "FPad.h"
+#include "font.h"
+#include "global.h"
+#include "http.h"
+#include "menu.h"
+#include "update.h"
+
+#include "../../common/include/NintendontVersion.h"
+
+#include "ff_utf8.h"
+#include "unzip/miniunz.h"
+#include "unzip/ioapi.h"
+extern void changeToDefaultDrive();
+extern char launch_dir[MAXPATHLEN];
+
+typedef struct {
+	const char url[96];
+	const char text[30];
+	const char filename[30];
+	const u32 max_size;
+} downloads_t;
+
+typedef enum {
+	DOWNLOAD_DSX,
+	DOWNLOAD_DS0,
+	DOWNLOAD_DS1,
+	DOWNLOAD_DS2,
+	DOWNLOAD_DS4,
+	DOWNLOAD_DSS,
+	DOWNLOAD_DS3,
+	DOWNLOAD_STABLE,
+	DOWNLOAD_INITDI	
+} DOWNLOADS;
+
+static const downloads_t Downloads[] = { 
+	{"http://send0r.de/Nintendont/MasterMod/419.zip", "Downloading Nintendont v4.419", "419.zip", 0x400000}, // 4MB	
+	{"http://send0r.de/Nintendont/MasterMod/405.zip", "Downloading Nintendont v3.405", "405.zip", 0x400000}, // 4MB	
+	{"http://send0r.de/Nintendont/MasterMod/397.zip", "Downloading Nintendont v3.397", "397.zip", 0x400000}, // 4MB	
+	{"http://send0r.de/Nintendont/MasterMod/353.zip", "Downloading Nintendont v3.353", "353.zip", 0x400000}, // 4MB	
+	{"http://send0r.de/Nintendont/MasterMod/321.zip", "Downloading Nintendont v3.321", "321.zip", 0x400000}, // 4MB	
+	{"http://send0r.de/Nintendont/MasterMod/319.zip", "Downloading Nintendont v3.319", "319.zip", 0x400000}, // 4MB		
+	{"http://send0r.de/Nintendont/MasterMod/296.zip", "Downloading Nintendont v2.296", "296.zip", 0x400000}, // 4MB	
+	{"http://send0r.de/Nintendont/MasterMod/stable.zip", "Downloading Nintendont v3.406", "stable.zip", 0x400000}, // 4MB	
+	{"http://send0r.de/Nintendont/MasterMod/229.zip", "Downloading Nintendont v2.229", "229.zip", 0x400000}, // 4MB	
+};
+
+static int UnzipDsx(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_DSX].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_DSX].filename);
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_DSX].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipDs0(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_DS0].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_DS0].filename);
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_DS0].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipDs1(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_DS1].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_DS1].filename);
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_DS1].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipDs2(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_DS2].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_DS2].filename);
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_DS2].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipDs4(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_DS4].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_DS4].filename);
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_DS4].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipDss(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_DSS].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_DSS].filename);
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_DSS].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipDs3(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_DS3].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_DS3].filename);
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_DS3].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipStable(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_STABLE].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_STABLE].filename);
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_STABLE].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipInitdi(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_INITDI].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_INITDI].filename);
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_INITDI].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static s32 Download(DOWNLOADS download_number)  {
+	ClearScreen();
+	
+	int line = 1;
+	int ret;
+	u32 http_status = 0;
+	u8* outbuf = NULL;
+	u32 filesize;
+	char filepath[MAXPATHLEN];
+	bool dir_argument_exists = strlen(launch_dir);
+	snprintf(filepath, sizeof(filepath), "%s%s", dir_argument_exists ? launch_dir : "/apps/Nintendont/", Downloads[download_number].filename);
+				if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[download_number].text);}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[download_number].text);}
+	UpdateScreen();
+	
+	line++;
+	gprintf("Downloading %s to %s\r\n", Downloads[download_number].url, filepath);
+	ret = net_init();
+	if(ret < 0) {
+		gprintf("Failed to init network\r\n");
+		goto end;
+	}
+	gprintf("Network Initialized\r\n");
+				if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+	UpdateScreen();
+	
+	int i;
+	for (i = 0; i <= 10; i++) {
+		ret = http_request(Downloads[download_number].url, Downloads[download_number].max_size);
+		if (ret) break;
+		if (i == 10) {
+			gprintf("Error making http request\r\n");
+			ret = -1;
+			goto end;
+		}
+	}
+
+	ret = http_get_result(&http_status, &outbuf, &filesize); 
+	if(((int)*outbuf & 0xF0000000) == 0xF0000000) 
+	{
+		ret = -2;
+		goto end;
+	}
+	UpdateScreen();
+	line++;
+	if (!dir_argument_exists) {
+		gprintf("Creating new directory\r\n");
+		f_mkdir_char("/apps/Nintendont");
+	}
+			 if (download_number == DOWNLOAD_DSX) {ret = UnzipDsx(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_DS0) {ret = UnzipDs0(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_DS1) {ret = UnzipDs1(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_DS2) {ret = UnzipDs2(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_DS4) {ret = UnzipDs4(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_DSS) {ret = UnzipDss(outbuf, filesize);}		
+		else if (download_number == DOWNLOAD_DS3) {ret = UnzipDs3(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_STABLE) {ret = UnzipStable(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_INITDI) {ret = UnzipInitdi(outbuf, filesize);}
+else
+	{
+		FIL file;
+		if (f_open_char(&file, filepath, FA_WRITE|FA_CREATE_ALWAYS) != FR_OK) {
+			gprintf("File Error\r\n");
+			ret = -3;
+			goto end;
+		} else {
+			UINT wrote;
+			f_write(&file, outbuf, filesize, &wrote);
+			f_close(&file);
+			ret = 1;			
+		}
+	}
+	if (ret == 1) {
+										if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+		UpdateScreen();
+		line++;
+	}
+end:
+	if (ret != 1)
+		{
+			if (which_bg == BG_NONE)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Update Error: %i", ret);
+			else if (which_bg == BG_LEGACY)
+			PrintFormat(DEFAULT_SIZE, YELLOW, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Update Error: %i", ret);
+
+		}
+	else
+	{									if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Restart Nintendont to complete update");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Restart Nintendont to complete update");}}
+	UpdateScreen();
+	if (outbuf != NULL) free(outbuf);
+	net_deinit();
+	sleep(3);
+	BackTheme();
+	return ret;
+}
+
+void UpdateOld(void) {
+	int selected = 0;
+	u64 delay = ticks_to_millisecs(gettime()) + 500;
+	while(true) {
+		ClearScreen();
+					if (which_bg == BG_NONE)
+					{		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*2, "Older Nintendont Download Menu");	
+		PrintFormat(15, BLACK, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");			
+		PrintInfo();
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Download Nintendont MasterMod (v4.419)");		
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Download Nintendont MasterMod (v3.405)");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*6, "Download Nintendont MasterMod (v3.397)");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Download Nintendont MasterMod (v3.353)");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*8, "Download Nintendont MasterMod (v3.321)");	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*9, "Download Nintendont MasterMod (v3.319)");			
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*10, "Download Nintendont MasterMod (v2.296)");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*11, "Download Nintendont MasterMod (v2.275)");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*12, "Download Nintendont MasterMod (v2.229)");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*13, "Return to Update Menu");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+					else if (which_bg == BG_LEGACY)
+					{		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*2, "Older Nintendont Download Menu");	
+		PrintFormat(15, WHITE, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");	
+		PrintInfo();
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Download Nintendont MasterMod (v4.419)");		
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Download Nintendont MasterMod (v3.405)");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*6, "Download Nintendont MasterMod (v3.397)");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Download Nintendont MasterMod (v3.353)");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*8, "Download Nintendont MasterMod (v3.321)");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*9, "Download Nintendont MasterMod (v3.319)");			
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*10, "Download Nintendont MasterMod (v2.296)");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*11, "Download Nintendont MasterMod (v2.275)");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*12, "Download Nintendont MasterMod (v2.229)");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*13, "Return to Update Menu");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+		GRRLIB_Render();
+		FPAD_Update();
+		if (delay > ticks_to_millisecs(gettime())) continue;
+		if (FPAD_Start(1)) {
+			ClearScreen();
+						if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, 212, 232, "Returning to loader...");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, 212, 232, "Returning to loader...");}
+			ExitToLoader(0);
+		}
+			if (FPAD_OK(1)) {
+			f_chdir_char("/apps/Nintendont");
+			if (selected <= (DOWNLOAD_INITDI))
+			Download(selected);
+			else
+				break;
+		}
+		if (FPAD_Down(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected++;
+			if (selected > 9) selected = 0;
+		}
+		if (FPAD_Up(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected--;
+			if (selected < 0) selected = 9;
+		}
+		if(FPAD_Y(0)) {
+				Credits();
+		}	
+		if (FPAD_Cancel(1)) {
+			break;
+		}
+	}
+	ClearScreen();
+	UpdateNintendont();
+}
Index: loader/source/update-other.c
===================================================================
--- loader/source/update-other.c	(nonexistent)
+++ loader/source/update-other.c	(working copy)
@@ -0,0 +1,368 @@
+/*
+
+Nintendont (Loader) - Playing Gamecubes in Wii mode on a Wii U
+
+Copyright (C) 2014  JoostinOnline
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation version 2.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+
+#include <gccore.h>
+#include <string.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <malloc.h>
+#include <network.h>
+
+#include <zlib.h>
+#include <ogc/lwp_watchdog.h>
+#include "ssl.h"
+#include "exi.h"
+#include "FPad.h"
+#include "font.h"
+#include "global.h"
+#include "http.h"
+#include "menu.h"
+#include "update.h"
+
+#include "../../common/include/NintendontVersion.h"
+
+#include "ff_utf8.h"
+#include "unzip/miniunz.h"
+#include "unzip/ioapi.h"
+extern void changeToDefaultDrive();
+extern char launch_dir[MAXPATHLEN];
+
+typedef struct {
+	const char url[96];
+	const char text[30];
+	const char filename[30];
+	const u32 max_size;
+} downloads_t;
+
+typedef enum {
+	DOWNLOAD_NINTENDONT = 0,
+	DOWNLOAD_DS2,
+	DOWNLOAD_DS3
+} DOWNLOADS;
+
+static const downloads_t Downloads[] = {
+	{"https://raw.githubusercontent.com/FIX94/Nintendont/master/loader/loader.dol", "Updating Nintendont", "boot.dol", 0x400000}, // 4MB
+	{"http://send0r.de/Nintendont/boot.zip", "Updating Nintendont", "boot.zip", 0x800000}, // 8MB
+	{"https://dl.dropboxusercontent.com/u/101209384/NintendontVersion.h", "Checking Latest Version", "", 0x400}, // 1KB	
+};
+
+static int UnzipDs2(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_DS2].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_DS2].filename);
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_DS2].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static inline bool LatestVersion(int *major, int *minor, int *current_line) {
+	u32 http_status = 0;
+	u8* outbuf = NULL;
+	u32 filesize;
+	int line = *current_line;
+				//	if (which_bg == BG_NONE)
+				//	{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[DOWNLOAD_VERSION].text);}
+				//	else if (which_bg == BG_LEGACY)
+				//	{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[DOWNLOAD_VERSION].text);}
+	UpdateScreen();
+	//line++;
+	/*if(!http_request(Downloads[DOWNLOAD_VERSION].url, Downloads[DOWNLOAD_VERSION].max_size)) {
+						if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Failed to retrieve version");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Failed to retrieve version");}
+		UpdateScreen();
+		*current_line = line;
+		return true; //false;
+	}*/
+
+	http_get_result(&http_status, &outbuf, &filesize);
+	
+	if (((int)*outbuf & 0xF0000000) == 0xF0000000) 
+	{
+		if (outbuf != NULL) free(outbuf);
+		*current_line = line;
+		return false;
+	}
+//	sscanf((char*)outbuf, " #ifndef %*s #define %*s #define NIN_MAJOR_VERSION %i #define NIN_MINOR_VERSION %i", major, minor);
+//	gprintf("major = %i, minor = %i\r\n", *major, *minor);
+	*major=3;
+	*minor=999;
+	if (outbuf != NULL) free(outbuf);
+	/*if ((*major <= NIN_MAJOR_VERSION) && (*minor <= NIN_MINOR_VERSION)) {
+		bool still_download = true;
+								if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "You already have the latest version");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "You already have the latest version");}
+		line++;
+								if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Download anyway? (A: Yes, B: No)");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Download anyway? (A: Yes, B: No)");}
+		line++;
+		UpdateScreen();
+		while(true) {
+			DrawBuffer();
+			FPAD_Update();
+			if (FPAD_Cancel(0)) {
+				gprintf("Cancelling download\n");
+				still_download = false;
+				break;
+			}
+			if (FPAD_OK(0)) {
+				gprintf("okay\n");
+				break;
+			}
+			GRRLIB_Render();
+		}
+		if(!still_download) {
+			*current_line = line;
+			return false;
+		}
+	} */
+	*current_line = line;
+	return (*major + *minor) > 0;
+
+}
+
+static s32 Download(DOWNLOADS download_number)  {
+	ClearScreen();
+	
+	int line = 1;
+	int ret, major = 0, minor = 0;
+	u32 http_status = 0;
+	u8* outbuf = NULL;
+	u32 filesize;
+	char filepath[MAXPATHLEN];
+	bool dir_argument_exists = strlen(launch_dir);
+	if (download_number == 0)
+	snprintf(filepath, sizeof(filepath), "%s%s", dir_argument_exists ? launch_dir : "/apps/Nintendont/", Downloads[download_number].filename);
+	else
+	snprintf(filepath, sizeof(filepath), "%s%s", dir_argument_exists ? launch_dir : "./", Downloads[download_number].filename);
+	
+								if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[download_number].text);}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[download_number].text);}
+	UpdateScreen();
+	
+	line++;
+	gprintf("Downloading %s to %s\r\n", Downloads[download_number].url, filepath);
+	ret = net_init();
+	if(ret < 0) {
+		gprintf("Failed to init network\r\n");
+		goto end;
+	}
+	gprintf("Network Initialized\r\n");
+									if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+	UpdateScreen();
+	ssl_init(); //only once needed
+	line++;
+	if (download_number == DOWNLOAD_NINTENDONT) {
+		ret = LatestVersion(&major, &minor, &line);
+		if (!ret) {
+										if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Download Cancelled");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Download Cancelled");}
+			UpdateScreen();
+			if (outbuf != NULL) free(outbuf);
+			net_deinit();
+			sleep(4);
+			return 0;
+		}
+								if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Downloading Nintendont");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Downloading Nintendont");}
+		UpdateScreen();
+		line++;
+	}
+	int i;
+	for (i = 0; i <= 10; i++) {
+		ret = http_request(Downloads[download_number].url, Downloads[download_number].max_size);
+		if (ret) break;
+		if (i == 10) {
+			gprintf("Error making http request\r\n");
+			ret = -1;
+			goto end;
+		}
+	}
+
+	ret = http_get_result(&http_status, &outbuf, &filesize); 
+	if(((int)*outbuf & 0xF0000000) == 0xF0000000) 
+	{
+		ret = -2;
+		goto end;
+	}
+									if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Download Complete");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Download Complete");}
+	UpdateScreen();
+	line++;
+	if (!dir_argument_exists) {
+		gprintf("Creating new directory\r\n");
+		f_mkdir_char("/apps");
+		f_mkdir_char("/apps/Nintendont");
+	}
+
+	// Write the file to disk.		
+if (download_number == DOWNLOAD_DS2) {ret = UnzipDs2(outbuf, filesize);}
+else
+	{
+		FIL file;
+		if (f_open_char(&file, filepath, FA_WRITE|FA_CREATE_ALWAYS) != FR_OK) {
+			gprintf("File Error\r\n");
+			ret = -3;
+			goto end;
+		} else {
+			UINT wrote;
+			f_write(&file, outbuf, filesize, &wrote);
+			f_close(&file);
+			ret = 1;			
+		}
+	}
+	if (ret == 1) {
+										if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+		UpdateScreen();
+		line++;
+	}
+end:
+	if (ret != 1)
+		{
+			if (which_bg == BG_NONE)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*line, "Update Error: %i", ret);
+			else if (which_bg == BG_LEGACY)
+			PrintFormat(DEFAULT_SIZE, YELLOW, MENU_POS_X, MENU_POS_Y + 20*line, "Update Error: %i", ret);
+		}
+	else
+	{									if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Restart Nintendont to complete update");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Restart Nintendont to complete update");}}
+		
+	UpdateScreen();
+	if (outbuf != NULL) free(outbuf);
+	net_deinit();
+	sleep(3);
+	//BackTheme();
+	return ret;
+}
+
+
+void UpdateOther(void) {
+	int selected = 0;
+	u64 delay = ticks_to_millisecs(gettime()) + 500;
+	while(true) {
+		ClearScreen();
+		if (which_bg == BG_NONE)
+					{		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");		
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*2, "Updates & Themes Menu");
+		PrintFormat(15, BLACK, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");		
+		PrintInfo();
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Download Official Nintendont (Latest Revision)");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Download Nintendont Mysterio's Mod by Sendor");	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*6, "Download Nintendont MasterMod (Stable Revisions)");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Return to Update Menu");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+					else if (which_bg == BG_LEGACY)
+					{		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");		
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*2, "Updates & Themes Menu");
+		PrintFormat(15, WHITE, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");		
+		PrintInfo();
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Download Official Nintendont (Latest Revision)");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Download Nintendont Mysterio's Mod by Sendor");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*6, "Download Nintendont MasterMod (Stable Revisions)");			
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Return to Update Menu");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+
+		GRRLIB_Render();
+		FPAD_Update();
+		if (delay > ticks_to_millisecs(gettime())) continue;
+		if (FPAD_Start(1)) {
+			ClearScreen();
+					if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, 212, 232, "Returning to loader...");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, 212, 232, "Returning to loader...");}
+			ExitToLoader(0);
+		}
+		if (FPAD_OK(1)) {		
+			f_chdir_char("/apps/Nintendont");
+			if (selected <= (DOWNLOAD_DS2))
+			Download(selected);
+			else if (selected == (DOWNLOAD_DS3))
+			UpdateOld();
+			else
+				break;
+		}
+		if (FPAD_Down(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected++;
+			if (selected > 3) selected = 0;
+		}
+		if (FPAD_Up(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected--;
+			if (selected < 0) selected = 3;
+		}
+		if(FPAD_Y(0)) {
+				Credits();
+		}
+		if (FPAD_Cancel(1)) {
+			break;
+		}
+	}
+	ClearScreen();
+	UpdateNintendont();
+}
